#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <dos.h>
#include <math.h>

#define ENTER 13
#define ESC   27
#define UP    72
#define DOWN  80
#define LEFT  75
#define RIGHT 77
#define PLUS  43
#define MINUS 45
#define CTRL_PLUS  144
#define CTRL_MINUS 142

#define PERIODA_PWM       100
#define CAS_NA_ZASTAVENI  2000


typedef void interrupt (*P_PRER) (void);//typ ukazatel na obsluhu prerus.

P_PRER stara_adresa_od_portu, stara_adresa_od_casovace;	//promenna pro uschovu stare adresy

volatile unsigned char tiky1 = 100;
volatile unsigned int tiky2 = 0;


volatile unsigned int pocet_preruseni = 0;
volatile float reg_zasah = 0;
volatile unsigned char min_vstup = 0, vstup = 0, zobrazit = 1;
volatile signed char smer = 0, poz_smer = 1;
volatile signed long poloha = 0, poz_poloha = 0;

void interrupt casovac(void)		//obsluha preruseni casovace
{
  tiky1 ++;
  tiky2 ++;
//  if (tiky2 > CAS_NA_ZASTAVENI) {rychlost = 0;};
  if (tiky1 >= PERIODA_PWM)
  {
    tiky1 = 0;
    switch (poz_smer)
    {
      case -1: outportb(0x378,0x01); break;
      case  1: outportb(0x378,0x02); break;
      default: outportb(0x378,0x00);
    }
  };
  if (tiky1 >= reg_zasah) {outportb(0x378,0x00);
  }


  (*stara_adresa_od_casovace)();			//volani puvodni obsluhy preruseni
}

void interrupt port(void)		//obsluha preruseni portu
{
  unsigned char vstup;

  pocet_preruseni++;

  vstup = inportb(0x379);

  vstup &= 0x30;
  vstup >>= 4;


  switch (5*vstup+min_vstup) {
    case 1:
    case 8:
    case 10:
    case 17: smer = -1; break;
    case 2:
    case 5:
    case 13:
    case 16: smer = 1; break;
    default: smer = 0;
  }
  poloha += smer;
  min_vstup = vstup;

//  if (tiky2 > 0) {rychlost = 800/tiky2;};
//  tiky2 = 0;


  (*stara_adresa_od_portu)();			//volani puvodni obsluhy preruseni
  outportb(0x20,0x20);				//ukonceni preruseni
}

void nakresli(void)		//obsluha preruseni casovace
{
   textattr(7);
   clrscr();

   gotoxy(10,3);
   cprintf("Merene otacky                 Pozadovane otacky");

   gotoxy(10,12);
   cprintf("Namerena poloha               Pozadovana poloha");

   gotoxy(10,25);
   cprintf("Esc - konec; / - otacky/poloha");

   textattr(16*3); //3 nebo 7

   gotoxy(9,4);
   cprintf("ͻ");
   gotoxy(9,5);
   cprintf("ݺ                  ");
   gotoxy(9,6);
   cprintf("ͼ");
   gotoxy(39,4);
   cprintf("ͻ");
   gotoxy(39,5);
   cprintf("ݺ                  ");
   gotoxy(39,6);
   cprintf("ͼ");

   gotoxy(9,13);
   cprintf("ͻ");
   gotoxy(9,14);
   cprintf("ݺ                  ");
   gotoxy(9,15);
   cprintf("ͼ");
   gotoxy(39,13);
   cprintf("ͻ");
   gotoxy(39,14);
   cprintf("ݺ                  ");
   gotoxy(39,15);
   cprintf("ͼ");

   gotoxy(42,5);

}

void main(void)
{
  unsigned int i, j, mod = 1, edit = 3, skoncit = 0;
  unsigned char poz_rychlost = 0;
  float rozdil = 0.0, rychlost = 0.0, integrator = 0.0;

//
  float time_coef = 1600;
  unsigned long new_const;
//

  stara_adresa_od_casovace = getvect(0x1C);		//zjisteni stare adresy z prerusovaciho vektoru casovace
  setvect(0x1C, casovac);		//zapis adresy nasi obsluhy do prerusovaciho vektoru casovace
  stara_adresa_od_portu = getvect(0x0F);		//zjisteni stare adresy z prerusovaciho vektoru portu
  setvect(0x0F, port);			//zapis adresy nasi obsluhy do prerusovaciho vektoru portu

  i = inportb(0x21);			//zapis na port
  outportb(0x21,i & 0x7F);
  j = inportb(0x37A);			//zapis do radice preruseni
  outportb(0x37A,j | 0x10);

//
  new_const = 65535/time_coef;

  outportb(0x43, 0x34);
  outportb(0x40, new_const%256);
  outportb(0x40, new_const/256);
//

  nakresli();

  while (1)
    {

    if (tiky2 >= 3280)
      {
      rychlost = (float)pocet_preruseni/2.0;
      pocet_preruseni = 0;
      tiky2 = 0;

      rozdil = (float)poz_rychlost - rychlost;
//      if (rozdil > 50.0) rozdil = 50.0;
//      if (rozdil < -50.0) rozdil = -50.0;
      if (fabs(rozdil) < 2)
        {
	integrator += (float)rozdil/20.0;
	}
      else
        {
	if (rozdil > 0.0) integrator = integrator + (float)rozdil/2.0;
	if (rozdil < 0.0) integrator = integrator + (float)rozdil;
        }
      if (integrator > 100.0) {integrator = 100.0;}
      if (integrator < 0.0) {integrator = 0.0;}
//puvodne   reg_zasah = (signed int)integrator;
//pro polohu
//      if (mod == 2)
        {
        if (poz_poloha > poloha)
        {
        poz_smer = 1;
	if (labs(poz_poloha - poloha) < 100) reg_zasah = 4; else reg_zasah = labs(poz_poloha - poloha)/10;
        }
        else if (poz_poloha < poloha)
        {
        poz_smer = -1;
        if (labs(poz_poloha - poloha) < 100) reg_zasah = 4; else reg_zasah = labs(poz_poloha - poloha)/10;
        }
        else reg_zasah = 0;
;

	}


    if (kbhit() != 0) {
      switch (getch()) {
        case ENTER: edit = 3; break;
	case ESC: skoncit = 1; break;
        case PLUS: if (edit != 3)
	             {
		     switch (edit) {
                       case 1: if (poz_rychlost < 100) {poz_rychlost++;}; break;
                       case 2: if (poz_poloha < 10000) {poz_poloha++;}; break;
                       case 0: poz_smer = 1; break;
                       default: ;
                       }
		     break;
                     }
        case MINUS: if (edit != 3)
	              {
		      switch (edit) {
                        case 1: if (poz_rychlost > 0) {poz_rychlost--;}; break;
                        case 2: if (poz_poloha > -10000) {poz_poloha--;}; break;
                        case 0: poz_smer = -1; break;
                        default: ;
                        }
		      break;
                      }
	case 0: switch (getch()) {
		  case UP:
		  case LEFT: edit = 1; mod = 1; break;
                  case RIGHT: edit = 0; mod = 2; break;
		  case DOWN: edit = 2; mod = 1; break;
                  case CTRL_PLUS: if (edit != 3)
                                    {
				    switch (edit) {
                                      case 1: if (poz_rychlost <= 90) {poz_rychlost += 10;} else {poz_rychlost = 100;}; break;
                                      case 2: if (poz_poloha <= 9900) {poz_poloha += 100;} else {poz_poloha = 10000;}; break;
                                      default: ;
                                      }
				    break;
                                    }
                  case CTRL_MINUS: if (edit != 3)
                                     {
				     switch (edit) {
                                       case 1: if (poz_rychlost >= 10) {poz_rychlost -= 10;} else {poz_rychlost = 0;}; break;
                                       case 2: if (poz_poloha >= -9900) {poz_poloha -= 100;} else {poz_poloha = -10000;}; break;
                                       default: ;
                                       }
				     break;
                                     }
		  }; break;
	}
      }
      }
    gotoxy(15,14);
    cprintf("%ld ", poloha);
    gotoxy(10,18); cprintf("integr %f", integrator);
    gotoxy(10,19); cprintf("rozdil %f", rozdil);
    gotoxy(15,5);
    cprintf("%f  ", rychlost);
    gotoxy(26,5);
    switch (smer) {
      case -1: cprintf(""); break;
      case  0: cprintf(" "); break;
      case  1: cprintf(""); break;
      default: ;
    };

    gotoxy(45,14);
    if (edit == 2) {textattr(16*3+4);}
    cprintf("%ld ", poz_poloha);
    textattr(16*3);
    if (edit == 1) {textattr(16*3+4);}
    gotoxy(43,5);
    cprintf("%d  ", poz_rychlost);
    textattr(16*3);
    if (edit == 0) {textattr(16*3+4);}
    gotoxy(56,5);
    switch (poz_smer) {
      case -1: cprintf(""); break;
      case  0: cprintf(" "); break;
      case  1: cprintf(""); break;
      default: ;
    };
    textattr(16*3);

//  if (poloha >= 200) {poz_rychlost = 0;};

    if (skoncit) {break;};
  }

//
  outportb(0x43, 0x34);
  outportb(0x40, 0xFF);
  outportb(0x40, 0xFF);
//

  outportb(0x378,0x00);
  outportb(0x21,i);			//vraceni puvodnich hodnot
  outportb(0x37A,j);
  setvect(0x1C, stara_adresa_od_casovace);
  setvect(0x0F, stara_adresa_od_portu);
}

/******* PORTY *******

typedef void interrupt (*P_PRER) (void);//typ ukazatel na obsluhu prerus.

P_PRER stara_adresa;			//promenna pro uschovu stare adresy

volatile unsigned int kusy = 0;
volatile unsigned char znacka = 1;

void interrupt port(void)		//obsluha preruseni portu
{
  kusy++;
  znacka = 1;
  (*stara_adresa)();			//volani puvodni obsluhy preruseni
  outportb(0x20,0x20);
}

void main()
{
  unsigned int i, j, bedny = 0;

  stara_adresa = getvect(0x0F);		//zjisteni stare adresy z prerusovaciho vektoru
  setvect(0x0F, port);			//zapis adresy nasi obsluhy do prerusovaciho vektoru

  i = inportb(0x21);			//zapis na port
  outportb(0x21,i & 0x7F);
  j = inportb(0x37A);			//zapis do radice preruseni
  outportb(0x37A,j | 0x10);
  outportb(0x378,0x03);

  clrscr();
  while (1) {
    if (znacka) {
      znacka = 0;
      bedny = kusy / 7;
      if (!(kusy % 7)) {
      clrscr();
      printf("Vymenuji bednu...");
      outportb(0x378,0x01);
      delay(2000);
      outportb(0x378,0x03);
      }
      clrscr();
      printf("Beden %d z 5, kusu %d ze 7, celkem %d.", bedny, kusy - 7*bedny, kusy);
      sound(880); delay(50); nosound();
    }
    if (kbhit() != 0)
      if (getch() == 27)
	break;
    if (kusy == 35) {
      clrscr();
      printf("Hotovo...");
      outportb(0x378,0x02);
      while(!kbhit());
      break;
    }
  }

  outportb(0x378,0x00);
  outportb(0x21,i);			//vraceni puvodnich hodnot
  outportb(0x37A,j);
  setvect(0x0F, stara_adresa);
}
*/
