//PROTOKOL MYSI

//Byte 1: x 1 LB RB Y7 Y6 X7 X6
//Byte 2: x 0 X5 X4 X3 X2 X1 X0
//Byte 3: x 0 Y5 Y4 Y3 Y2 Y1 Y0

//LB - stav leveho tlac.; 1=stisknuto
//X7 az X0 - zmena polohy oproti predchozimu hlaseni (byte se znam.)

/********/

//ma ukazovat stav mysi a jezdit po obrazovce kurzorem

#include <stdio.h>
#include <conio.h>
#include <dos.h>

#define COM2  //zde zvolit patricny COM port pro komunikaci

#ifdef COM2
  #define BASE 0x2f8
  int irq_mask=0x8;
  int int_num=0xb;
#endif

#ifdef COM1
  #define BASE 0x3f8
  int irq_mask=0x10;
  int int_num=0xc;
#endif

#ifndef BASE
  #error Neni specifikovan COM1/COM2
#endif

unsigned int old_mask;

volatile char inp_byte = 0;
volatile unsigned char znacka = 1;

void interrupt ( *oldhandler)();

void interrupt handler()
{
   /*vlastni obslouzeni preruseni zde!*/
   inp_byte = inportb(BASE);
   znacka++;

   oldhandler();
}

void main()
{
  unsigned char lb = 0, rb = 0, inp_byte_num=2;
  int x=400, y=130;
  int inp_x = 0, inp_y = 0;

  disable();			//zakazani preruseni
  outportb(BASE+3, 0x80);	//DLAB=1
  outportb(BASE, 96);		//predvolba na 1200Bd low
  outportb(BASE+1, 0);		//		      high
  outportb(BASE+3, 2);		//7 dat. bitu, bez parity, 1 stopbit
  outportb(BASE+1, 1);		//povoleni INT od prijateho znaku

  oldhandler=getvect(int_num);
  setvect(int_num, handler);

  old_mask=inportb(0x21) & irq_mask;
  outportb(0x21, inportb(0x21) & ~irq_mask);

  enable();			//povoleni preruseni
  clrscr();

  while(!kbhit())
  {
    if (znacka) {
      znacka = 0;
      if (inp_byte & 0x40)
	inp_byte_num = 1;
      else
	if (inp_byte_num > 0) inp_byte_num++;
      switch (inp_byte_num) {
	case 1: lb = (inp_byte & 0x20) >> 5;
		rb = (inp_byte & 0x10) >> 4;
		inp_x = (inp_byte & 0x3) << 6;
		inp_y = (inp_byte & 0xC) << 4;
		break;
	case 2: inp_x |= inp_byte & 0x3F;
		break;
	case 3: inp_y |= inp_byte & 0x3F;
		clrscr();
//		gotoxy(1, 1);
//		printf("dx:%i,dy:%i",inp_x,inp_y);
		x += (signed char)inp_x;
		y += (signed char)inp_y;
		if (x < 8) x = 8;
		if (x > 615) x = 615;
		if (y < 16) y = 16;
		if (y > 383) y = 383;
		//176 180  185  190  195  200  205  210  215  220
		//
		gotoxy(x/8, y/16);
		printf("Ŀ");
		gotoxy(x/8, y/16+1);
		printf("%c%c", lb*223, rb*223);
		gotoxy(x/8, y/16+2);
		printf("");
		if (lb) {
		  gotoxy(x/8+1, y/16);
		  printf("");
		}
		if (rb) {
		  gotoxy(x/8+3, y/16);
		  printf("");
		}
		gotoxy(1,1);
                inp_byte_num=0;
                break;
      }
    }
  }
  getch();

  disable();
  outportb(0x21, inportb(0x21) | old_mask);
  setvect(int_num, oldhandler);

}
